<template>
    <div class="custom-card">
        <h2>Weather</h2>
        <div class="row">
            <div class="col-sm-6">
                <div class="form-group">
                    <label class="input-city">
                        City:
                        <div class="position-relative mt-2">
                            <input type="text"
                                   class="form-control"
                                   :class="{'error': $v.city.$error}"
                                   placeholder="type the city's name"
                                   v-model.trim="$v.city.$model" />
                            <div class="icon plus"
                                 v-if="weather"
                                 @click="addToFavourites">+</div>
                        </div>
                    </label>
                </div>
                <div>
                    <button class="btn btn-primary"
                            @click="submit">Submit</button>
                </div>
            </div>
            <div class="col-sm-6">
                <div v-if="weather">
                    <weather :weather="weather" />
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import Weather from './Weather';
    import { required } from 'vuelidate/lib/validators'

    export default {
        name: "Dashboard",
        components: {
            Weather
        },
        data() {
            return {
                city: '',
                weather: null
            }
        },
        validations: {
            city: {
                required
            }
        },
        methods: {
            submit() {
                openWeatherAPI('/data/2.5/weather', {
                    params: {
                        q: this.city,
                        APPID: process.env.VUE_APP_API_KEY
                    }
                })
                    .then(({data}) => this.weather = data.main)
                    .catch(({response: {data: {message}}}) => {
                        this.$notify({
                            group: 'error',
                            type: 'warn',
                            text: message
                        });
                        this.weather = null;
                    });
            },
            addToFavourites() {
                if (localStorage.getItem('favourites')) {
                    let cities = JSON.parse(localStorage.getItem('favourites'));
                    let indexOf = cities.indexOf(this.city);
                    if (indexOf !== -1) {
                        this.$notify({
                            group: 'error',
                            type: 'warn',
                            text: 'This city has already in favourites'
                        })
                    } else {
                        cities.push(this.city);
                        localStorage.setItem('favourites', JSON.stringify(cities));
                    }
                } else {
                    let cities = [];
                    cities.push(this.city);
                    localStorage.setItem('favourites', JSON.stringify(cities));
                }
            }
        }
    }
</script>

<style scoped lang="scss">
    $plus_width: 22px;

    .input-city {
        margin: 0;

        input {
            padding-right: calc(#{$plus_width} + 10px);
        }
    }

    .plus {
        width: $plus_width;
        height: $plus_width;
        border-radius: 50%;
        box-shadow: 0 0 1px 1px silver;
        display: flex;
        align-items: center;
        justify-content: center;
        background-color: green;
        color: white;
        font-weight: bold;
        font-size: 20px;
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        right: 5px;
    }
</style>